diff --git a/service/src/main/cpp/mcu_transport.c b/service/src/main/cpp/mcu_transport.c
index 19a1d6a..5f5828a 100644
--- a/service/src/main/cpp/mcu_transport.c
+++ b/service/src/main/cpp/mcu_transport.c
@@ -442,6 +442,8 @@ bool mcu_link_send_data_frame(McuLink *ctx, uint8_t ft, const uint8_t *payload,
     if (seq_out != NULL) {
         *seq_out = seq;
     }
+    MCU_LOGI("[TX] seq=%u ft=0x%02X payload=%zuB sent=%s",
+             (unsigned)seq, ft, payload_len, ok ? "OK" : "FAIL");
     return ok;
 }
 
@@ -720,10 +722,15 @@ bool mcu_link_wait_for_ack(McuLink *ctx, uint8_t expected_seq, int timeout_ms)
         }
         if (deferred_count < ARRAY_SIZE(deferred)) {
             deferred[deferred_count++] = event;
+        } else {
+            MCU_LOGW("[DROP] deferred overflow, dropping ft=0x%02X seq=%u",
+                     event.frame.ft, event.frame.seq);
         }
     }
 
     event_queue_restore_front(&ctx->events, deferred, deferred_count);
+    MCU_LOGW("[TIMEOUT] wait_for_ack expected_seq=%u timeout=%dms deferred=%zu",
+             (unsigned)expected_seq, timeout_ms, deferred_count);
     return false;
 }
 
@@ -780,6 +787,8 @@ bool mcu_link_wait_for_update_frame(McuLink *ctx, int timeout_ms, McuFrame *fram
             return true;
         }
         /* drop non-update frames (already auto-ACKed by reader) */
+        MCU_LOGW("[DROP] wait_for_update dropped ft=0x%02X seq=%u",
+                 event.frame.ft, event.frame.seq);
     }
     return false;
 }
diff --git a/service/src/main/java/com/qsjnic/mcu/service/FrameRouter.java b/service/src/main/java/com/qsjnic/mcu/service/FrameRouter.java
index e3d589a..c9803fd 100644
--- a/service/src/main/java/com/qsjnic/mcu/service/FrameRouter.java
+++ b/service/src/main/java/com/qsjnic/mcu/service/FrameRouter.java
@@ -29,6 +29,7 @@ public final class FrameRouter {
 
     // MsgType constants.
     private static final int MSG_TYPE_PUBLIC = 0x01;
+    private static final int MSG_TYPE_KEY    = 0x02;
     private static final int MSG_TYPE_RADIO  = 0x05;
     private static final int MSG_TYPE_UPDATE = 0x07;
 
@@ -67,6 +68,9 @@ public final class FrameRouter {
             case MSG_TYPE_PUBLIC:
                 handlePublic(frameType, cmd, payload, len);
                 break;
+            case MSG_TYPE_KEY:
+                handleKey(frameType, cmd, payload, len);
+                break;
             case MSG_TYPE_RADIO:
                 handleRadio(frameType, cmd, payload, len);
                 break;
@@ -126,6 +130,18 @@ public final class FrameRouter {
         }
     }
 
+    // ------------------------------------------------------------ Key
+
+    private static void handleKey(int frameType, int cmd, byte[] p, int len) {
+        if (cmd == 0x01 && len >= 2) {
+            Log.i(TAG, String.format("KEY value=0x%02X status=0x%02X",
+                    p[0] & 0xFF, p[1] & 0xFF));
+            return;
+        }
+        Log.i(TAG, String.format("KEY cmd=0x%02X type=0x%02X len=%d",
+                cmd, frameType, len));
+    }
+
     // ------------------------------------------------------------ Radio
 
     private static void handleRadio(int frameType, int cmd, byte[] p, int len) {
diff --git a/service/src/main/java/com/qsjnic/mcu/service/McuBinder.java b/service/src/main/java/com/qsjnic/mcu/service/McuBinder.java
index b5156d5..42ee02d 100644
--- a/service/src/main/java/com/qsjnic/mcu/service/McuBinder.java
+++ b/service/src/main/java/com/qsjnic/mcu/service/McuBinder.java
@@ -2,8 +2,10 @@ package com.qsjnic.mcu.service;
 
 import android.os.RemoteCallbackList;
 import android.os.RemoteException;
+import android.util.Log;
 
 import com.qsjnic.mcu.contract.IMcuFrameListener;
+import com.qsjnic.mcu.contract.IMcuKeyListener;
 import com.qsjnic.mcu.contract.IMcuRadioListener;
 import com.qsjnic.mcu.contract.IMcuService;
 import com.qsjnic.mcu.contract.IMcuUpgradeListener;
@@ -20,24 +22,29 @@ import com.qsjnic.mcu.domain.Cmds;
 import com.qsjnic.mcu.domain.Commands;
 import com.qsjnic.mcu.domain.MsgType;
 
+import com.qsjnic.mcu.service.feature.KeyFeature;
 import com.qsjnic.mcu.service.feature.RadioFeature;
 import com.qsjnic.mcu.service.feature.UpgradeFeature;
 import com.qsjnic.mcu.service.feature.VehicleFeature;
 
 public class McuBinder extends IMcuService.Stub {
 
+    private static final String TAG = "McuBinder";
+
     private static final int OK              = McuErrorCode.OK;
     private static final int ERR_LINK_DOWN   = McuErrorCode.ERR_LINK_DOWN;
     private static final int ERR_INVALID_ARG = McuErrorCode.ERR_INVALID_ARG;
 
     private final VehicleFeature vehicle;
+    private final KeyFeature key;
     private final RadioFeature radio;
     private final UpgradeFeature upgrade;
     private final RemoteCallbackList<IMcuFrameListener> frameListeners;
 
-    public McuBinder(VehicleFeature vehicle, RadioFeature radio, UpgradeFeature upgrade,
+    public McuBinder(VehicleFeature vehicle, KeyFeature key, RadioFeature radio, UpgradeFeature upgrade,
                      RemoteCallbackList<IMcuFrameListener> frameListeners) {
         this.vehicle = vehicle;
+        this.key = key;
         this.radio = radio;
         this.upgrade = upgrade;
         this.frameListeners = frameListeners;
@@ -107,6 +114,32 @@ public class McuBinder extends IMcuService.Stub {
         int seq = McuLink.get().sendAndWaitAck(MsgType.PUBLIC, Cmds.Public.AMP_PWR, Commands.Public.ampPower(on), 1500); return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
     }
 
+    // ---- Key ----
+
+    @Override
+    public void registerKeyListener(IMcuKeyListener cb) throws RemoteException {
+        key.register(cb);
+    }
+
+    @Override
+    public void unregisterKeyListener(IMcuKeyListener cb) throws RemoteException {
+        key.unregister(cb);
+    }
+
+    @Override
+    public int sendKeyEvent(int keyValue, int keyStatus) throws RemoteException {
+        try {
+            byte[] payload = Commands.Key.key(keyValue, keyStatus);
+            if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
+            int seq = McuLink.get().sendAndWaitAck(MsgType.KEY, Cmds.Key.A2M_KEY, payload, 1500);
+            Log.i(TAG, String.format("sendKeyEvent key=0x%02X status=0x%02X seq=%d", keyValue, keyStatus, seq));
+            return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
+        } catch (IllegalArgumentException e) {
+            Log.w(TAG, "sendKeyEvent invalid arg: " + e.getMessage());
+            return ERR_INVALID_ARG;
+        }
+    }
+
     // ---- Radio ----
 
     @Override
@@ -126,8 +159,13 @@ public class McuBinder extends IMcuService.Stub {
 
     @Override
     public int setBand(int band) throws RemoteException {
+        return setBandWithFreq(band, 0);
+    }
+
+    @Override
+    public int setBandWithFreq(int band, int freq) throws RemoteException {
         try {
-            byte[] payload = Commands.Radio.setBand(band);
+            byte[] payload = Commands.Radio.setBand(band, freq);
             if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
             int seq = McuLink.get().sendAndWaitAck(MsgType.RADIO, Cmds.Radio.SET_BAND, payload, 1500); return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
         } catch (IllegalArgumentException e) {
@@ -232,6 +270,12 @@ public class McuBinder extends IMcuService.Stub {
         return UpgradeManager.getInstance().sendBootUpgradeChecksum(checksum);
     }
 
+    @Override
+    public int sendBootUpgradeChecksumMd5(byte[] md5) throws RemoteException {
+        if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
+        return UpgradeManager.getInstance().sendBootUpgradeChecksumMd5(md5);
+    }
+
     // ---- Public A2M ----
 
     @Override
@@ -333,8 +377,18 @@ public class McuBinder extends IMcuService.Stub {
 
     @Override
     public int requestTripClear() throws RemoteException {
-        if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
-        int seq = McuLink.get().sendAndWaitAck(MsgType.PUBLIC, Cmds.Public.TRIP_CLEAR, Commands.Public.reqTripClear(), 1500); return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
+        return requestTripClearType(1);
+    }
+
+    @Override
+    public int requestTripClearType(int type) throws RemoteException {
+        try {
+            byte[] payload = Commands.Public.reqTripClear(type);
+            if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
+            int seq = McuLink.get().sendAndWaitAck(MsgType.PUBLIC, Cmds.Public.TRIP_CLEAR, payload, 1500); return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
+        } catch (IllegalArgumentException e) {
+            return ERR_INVALID_ARG;
+        }
     }
 
     @Override
@@ -361,9 +415,24 @@ public class McuBinder extends IMcuService.Stub {
 
     @Override
     public int setGpsInfo(int latE6, int lonE6, int speedKmh, int heading) throws RemoteException {
-        if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
-        byte[] payload = Commands.Public.gpsInfo(latE6, lonE6, speedKmh, heading);
-        int seq = McuLink.get().sendAndWaitAck(MsgType.PUBLIC, Cmds.Public.GPS_INFO, payload, 1500); return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
+        try {
+            byte[] payload = Commands.Public.gpsInfo(latE6, lonE6, speedKmh, heading);
+            if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
+            int seq = McuLink.get().sendAndWaitAck(MsgType.PUBLIC, Cmds.Public.GPS_INFO, payload, 1500); return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
+        } catch (IllegalArgumentException e) {
+            return ERR_INVALID_ARG;
+        }
+    }
+
+    @Override
+    public int setGpsInfoFull(int moduleStatus, int lonPpm, int lonStatus, int latPpm, int latStatus) throws RemoteException {
+        try {
+            byte[] payload = Commands.Public.gpsInfoFull(moduleStatus, lonPpm, lonStatus, latPpm, latStatus);
+            if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
+            int seq = McuLink.get().sendAndWaitAck(MsgType.PUBLIC, Cmds.Public.GPS_INFO, payload, 1500); return seq >= 0 ? OK : McuErrorCode.ERR_TIMEOUT;
+        } catch (IllegalArgumentException e) {
+            return ERR_INVALID_ARG;
+        }
     }
 
     @Override
diff --git a/service/src/main/java/com/qsjnic/mcu/service/QsMcuSystemService.java b/service/src/main/java/com/qsjnic/mcu/service/QsMcuSystemService.java
index d1de110..24f0fb5 100644
--- a/service/src/main/java/com/qsjnic/mcu/service/QsMcuSystemService.java
+++ b/service/src/main/java/com/qsjnic/mcu/service/QsMcuSystemService.java
@@ -22,6 +22,8 @@ import com.qsjnic.mcu.contract.IMcuService;
 import com.qsjnic.mcu.contract.IMcuFrameListener;
 
 import com.qsjnic.mcu.service.feature.DomainBus;
+import com.qsjnic.mcu.service.feature.KeyFeature;
+import com.qsjnic.mcu.service.feature.KeyInjector;
 import com.qsjnic.mcu.service.feature.VehicleFeature;
 import com.qsjnic.mcu.service.feature.RadioFeature;
 import com.qsjnic.mcu.service.feature.UpgradeFeature;
@@ -33,7 +35,7 @@ import com.qsjnic.mcu.service.feature.UpgradeFeature;
 public class QsMcuSystemService extends Service {
 
     private static final String TAG = "QsMcuSystemService";
-    private static QsMcuSystemService sInstance;
+    private volatile static QsMcuSystemService sInstance;
 
     private static final String SERIAL_PORT = "/dev/ttyS7";
     private static final int    SERIAL_BAUD = 460800;
@@ -49,6 +51,7 @@ public class QsMcuSystemService extends Service {
 
     private DomainBus bus;
     private VehicleFeature vehicle;
+    private KeyFeature key;
     private RadioFeature radio;
     private UpgradeFeature upgrade;
 
@@ -57,22 +60,26 @@ public class QsMcuSystemService extends Service {
     @Override
     public void onCreate() {
         super.onCreate();
-        sInstance = this;
 
         vehicle = new VehicleFeature(frameListeners);
+        key     = new KeyFeature();
+        key.setInjector(new KeyInjector(this));
         radio   = new RadioFeature(frameListeners);
         upgrade = new UpgradeFeature(frameListeners);
         bus = new DomainBus();
         bus.register(vehicle);
+        bus.register(key);
         bus.register(radio);
         bus.register(upgrade);
+        // Expose singleton only after all fields are initialized.
+        sInstance = this;
         FrameRouter.setBus(bus);
         Log.i(TAG, "onCreate"
                 + " pid=" + Process.myPid()
                 + " uid=" + Process.myUid()
                 + " thread=" + Thread.currentThread().getName());
 
-        binder = new McuBinder(vehicle, radio, upgrade, frameListeners);
+        binder = new McuBinder(vehicle, key, radio, upgrade, frameListeners);
 
         // Foreground service notification (required on Android 8+ to stay alive).
         startForeground(NOTIF_ID, buildForegroundNotification());
@@ -180,8 +187,12 @@ public class QsMcuSystemService extends Service {
         Log.i(TAG, "onDestroy");
         sInstance = null;
         stopForeground(true);
-        McuLink.get().stop();
-        McuLink.get().close();
+        // sendCloseAndStop() already performs wait -> sendClose -> close.
+        McuLink.get().sendCloseAndStop();
+        // Stop background HandlerThreads so their Loopers don't leak across
+        // service restarts.
+        FrameRouter.quit();
+        UpgradeManager.getInstance().shutdown();
         super.onDestroy();
     }
 
@@ -221,6 +232,7 @@ public class QsMcuSystemService extends Service {
 
         pw.println("----- Listeners -----");
         pw.println("Vehicle listeners: " + vehicle.listenerCount());
+        pw.println("Key listeners:     " + key.listenerCount());
         pw.println("Radio listeners:   " + radio.listenerCount());
         pw.println("Upgrade listeners: " + upgrade.listenerCount());
     }
diff --git a/service/src/main/java/com/qsjnic/mcu/service/UpgradeManager.java b/service/src/main/java/com/qsjnic/mcu/service/UpgradeManager.java
index 5b57775..608799e 100644
--- a/service/src/main/java/com/qsjnic/mcu/service/UpgradeManager.java
+++ b/service/src/main/java/com/qsjnic/mcu/service/UpgradeManager.java
@@ -13,6 +13,9 @@ import com.qsjnic.mcu.contract.IMcuUpgradeListener;
 import com.qsjnic.mcu.contract.McuErrorCode;
 import com.qsjnic.mcu.contract.UpgradeProgress;
 import com.qsjnic.mcu.contract.UpgradeRequest;
+import com.qsjnic.mcu.domain.Commands;
+
+import java.io.File;
 
 /**
  * MCU OTA upgrade manager — thin wrapper around native {@link McuLink#runUpgrade}.
@@ -116,7 +119,20 @@ public final class UpgradeManager {
 
     public int startBootUpgrade(@Nullable UpgradeRequest req) {
         if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
-        return McuLink.get().sendBusinessFrame(0x07, 0x84, null) >= 0 ? ERR_OK : ERR_LINK_DOWN;
+        if (req == null || req.binFilePath == null || req.binFilePath.isEmpty()) {
+            return ERR_INVALID_ARG;
+        }
+        File bin = new File(req.binFilePath);
+        if (!bin.isFile() || bin.length() <= 0) return McuErrorCode.ERR_FILE;
+        String project = req.projectId == null || req.projectId.isEmpty() ? "10040" : req.projectId;
+        byte[] payload;
+        try {
+            payload = Commands.Update.bootBegin(bin.length(), project);
+        } catch (IllegalArgumentException e) {
+            return ERR_INVALID_ARG;
+        }
+        int seq = McuLink.get().sendAndWaitAck(0x07, 0x84, payload, 1500);
+        return seq >= 0 ? ERR_OK : McuErrorCode.ERR_TIMEOUT;
     }
 
     public int sendBootUpgradeData(byte[] chunk, int index) {
@@ -126,16 +142,24 @@ public final class UpgradeManager {
         payload[0] = (byte) ((index >> 8) & 0xFF);
         payload[1] = (byte) ( index       & 0xFF);
         System.arraycopy(chunk, 0, payload, 2, chunk.length);
-        return McuLink.get().sendBusinessFrame(0x07, 0x85, payload) >= 0 ? ERR_OK : ERR_LINK_DOWN;
+        int seq = McuLink.get().sendAndWaitAck(0x07, 0x85, payload, 1500);
+        return seq >= 0 ? ERR_OK : McuErrorCode.ERR_TIMEOUT;
     }
 
     public int sendBootUpgradeChecksum(int checksum) {
+        return ERR_INVALID_ARG;
+    }
+
+    public int sendBootUpgradeChecksumMd5(byte[] md5) {
         if (!McuLink.get().isLinkAlive()) return ERR_LINK_DOWN;
-        byte[] payload = new byte[] {
-                (byte) ((checksum >> 24) & 0xFF), (byte) ((checksum >> 16) & 0xFF),
-                (byte) ((checksum >> 8) & 0xFF),  (byte) ( checksum       & 0xFF)
-        };
-        return McuLink.get().sendBusinessFrame(0x07, 0x86, payload) >= 0 ? ERR_OK : ERR_LINK_DOWN;
+        byte[] payload;
+        try {
+            payload = Commands.Update.bootChecksumMd5(md5);
+        } catch (IllegalArgumentException e) {
+            return ERR_INVALID_ARG;
+        }
+        int seq = McuLink.get().sendAndWaitAck(0x07, 0x86, payload, 1500);
+        return seq >= 0 ? ERR_OK : McuErrorCode.ERR_TIMEOUT;
     }
 
     // ---------------------------------------------------- called from FrameRouter
diff --git a/service/src/main/java/com/qsjnic/mcu/service/feature/KeyFeature.java b/service/src/main/java/com/qsjnic/mcu/service/feature/KeyFeature.java
new file mode 100644
index 0000000..83a3599
--- /dev/null
+++ b/service/src/main/java/com/qsjnic/mcu/service/feature/KeyFeature.java
@@ -0,0 +1,67 @@
+package com.qsjnic.mcu.service.feature;
+
+import android.content.Context;
+import android.os.RemoteCallbackList;
+import android.os.RemoteException;
+import android.util.Log;
+
+import com.qsjnic.mcu.contract.IMcuKeyListener;
+import com.qsjnic.mcu.domain.Cmds;
+import com.qsjnic.mcu.domain.Decoders;
+import com.qsjnic.mcu.domain.MsgType;
+
+public final class KeyFeature implements Feature {
+
+    private static final String TAG = "KeyFeature";
+
+    private final RemoteCallbackList<IMcuKeyListener> typedListeners = new RemoteCallbackList<>();
+    private KeyInjector injector;
+
+    @Override public boolean accepts(int msgType) {
+        return msgType == MsgType.KEY;
+    }
+
+    @Override public void onFrame(int frameType, int msgType, int cmd, byte[] body) {
+        if (cmd == Cmds.Key.M2A_KEY) {
+            int[] v = Decoders.parseKeyControl(body);
+            if (v != null) broadcastKeyEvent(v[0], v[1]);
+            return;
+        }
+        Log.d(TAG, String.format("unknown KEY cmd=0x%02X", cmd));
+    }
+
+    public void register(IMcuKeyListener cb) {
+        typedListeners.register(cb);
+    }
+
+    public void unregister(IMcuKeyListener cb) {
+        typedListeners.unregister(cb);
+    }
+
+    /** Set the optional KeyInjector for system-level injection. */
+    public void setInjector(KeyInjector injector) {
+        this.injector = injector;
+    }
+
+    public int listenerCount() {
+        return typedListeners.getRegisteredCallbackCount();
+    }
+
+    private interface OneWayCall { void call(IMcuKeyListener cb) throws RemoteException; }
+
+    private void broadcastTyped(OneWayCall call) {
+        int n = typedListeners.beginBroadcast();
+        for (int i = 0; i < n; i++) {
+            try { call.call(typedListeners.getBroadcastItem(i)); }
+            catch (RemoteException ignored) {}
+        }
+        typedListeners.finishBroadcast();
+    }
+
+    private void broadcastKeyEvent(int keyValue, int keyStatus) {
+        broadcastTyped(cb -> cb.onKeyEvent(keyValue, keyStatus));
+        if (injector != null) {
+            injector.inject(keyValue, keyStatus);
+        }
+    }
+}
diff --git a/service/src/main/java/com/qsjnic/mcu/service/feature/KeyInjector.java b/service/src/main/java/com/qsjnic/mcu/service/feature/KeyInjector.java
new file mode 100644
index 0000000..592c13e
--- /dev/null
+++ b/service/src/main/java/com/qsjnic/mcu/service/feature/KeyInjector.java
@@ -0,0 +1,208 @@
+package com.qsjnic.mcu.service.feature;
+
+import android.content.Context;
+import android.hardware.input.InputManager;
+import android.os.SystemClock;
+import android.util.Log;
+import android.view.InputEvent;
+import android.view.KeyEvent;
+
+import androidx.annotation.NonNull;
+
+import java.lang.reflect.Method;
+
+/**
+ * 将 MCU Key 域按键事件注入 Android Input 子系统。
+ * <p>
+ * 调用方：KeyFeature（运行在 FrameRouter 的 HandlerThread 上）。
+ * 权限：需要 android.permission.INJECT_EVENTS，由 service 模块 manifest 声明。
+ * <p>
+ * 设计原则：
+ * - 保留现有 Listener 回调通道（给已集成 SDK 的应用精确控制）
+ * - 注入通道补充（给未集成 SDK 的系统应用标准 KeyEvent）
+ * - 两者并存，互不干扰
+ * <p>
+ * injectInputEvent 是 @hide API，通过反射调用。
+ */
+public final class KeyInjector {
+
+    private static final String TAG = "KeyInjector";
+
+    // ------ MCU keyValue 常量（与 McuKeyClient 保持一致） ------
+    public static final int KEY_VALUE_NONE            = 0x00;
+    public static final int KEY_VALUE_POWER           = 0x01;
+    public static final int KEY_VALUE_HOME            = 0x02;
+    public static final int KEY_VALUE_VOICE           = 0x03;
+    public static final int KEY_VALUE_MUSIC           = 0x04;
+    public static final int KEY_VALUE_RADIO           = 0x05;
+    public static final int KEY_VALUE_TEL             = 0x06;
+    public static final int KEY_VALUE_TFT             = 0x07;
+    public static final int KEY_VALUE_VOL_DEC         = 0x08;
+    public static final int KEY_VALUE_VOL_INC         = 0x09;
+    public static final int KEY_VALUE_MUTE            = 0x0C;
+    public static final int KEY_VALUE_MODE            = 0x0D;
+    public static final int KEY_VALUE_PREV            = 0x0E;
+    public static final int KEY_VALUE_NEXT            = 0x0F;
+    public static final int KEY_VALUE_ANSWER          = 0x18;
+    public static final int KEY_VALUE_REJECT          = 0x19;
+    public static final int KEY_VALUE_CAMERA          = 0x25;
+
+    // ------ MCU keyStatus 常量 ------
+    public static final int KEY_STATUS_RELEASE        = 0x00;
+    public static final int KEY_STATUS_SHORT_PRESS    = 0x01;
+    public static final int KEY_STATUS_STUCK          = 0x02;
+    public static final int KEY_STATUS_ENCODER_LEFT   = 0x03;
+    public static final int KEY_STATUS_ENCODER_RIGHT  = 0x04;
+
+    // ------ MCU keyValue → Android KeyEvent keyCode 映射 ------
+
+    private static int toAndroidKeyCode(int keyValue) {
+        switch (keyValue) {
+            case KEY_VALUE_VOL_DEC: return KeyEvent.KEYCODE_VOLUME_DOWN;
+            case KEY_VALUE_VOL_INC: return KeyEvent.KEYCODE_VOLUME_UP;
+            case KEY_VALUE_MUTE:    return KeyEvent.KEYCODE_VOLUME_MUTE;
+            case KEY_VALUE_HOME:    return KeyEvent.KEYCODE_HOME;
+            case KEY_VALUE_VOICE:   return KeyEvent.KEYCODE_VOICE_ASSIST;
+            case KEY_VALUE_PREV:    return KeyEvent.KEYCODE_MEDIA_PREVIOUS;
+            case KEY_VALUE_NEXT:    return KeyEvent.KEYCODE_MEDIA_NEXT;
+            case KEY_VALUE_ANSWER:  return KeyEvent.KEYCODE_CALL;
+            case KEY_VALUE_REJECT:  return KeyEvent.KEYCODE_ENDCALL;
+            case KEY_VALUE_MODE:    return KeyEvent.KEYCODE_APP_SWITCH;
+            case KEY_VALUE_MUSIC:   return KeyEvent.KEYCODE_MUSIC;
+            case KEY_VALUE_POWER:   return KeyEvent.KEYCODE_POWER;
+            case KEY_VALUE_CAMERA:  return KeyEvent.KEYCODE_CAMERA;
+            default:
+                Log.d(TAG, "unmapped keyValue=0x" + Integer.toHexString(keyValue));
+                return -1;
+        }
+    }
+
+    /** 编码器方向由 keyValue 决定：VOL_DEC=左旋（音量减），VOL_INC=右旋（音量加） */
+    private static int toEncoderKeyCode(int keyValue) {
+        switch (keyValue) {
+            case KEY_VALUE_VOL_DEC: return KeyEvent.KEYCODE_VOLUME_DOWN;
+            case KEY_VALUE_VOL_INC: return KeyEvent.KEYCODE_VOLUME_UP;
+            default: return -1;
+        }
+    }
+
+    private final InputManager inputManager;
+    private final Method injectMethod;
+    private boolean enabled = true;
+
+    /** Track the currently pressed key for correct downTime pairing on STUCK/RELEASE. */
+    private int pendingKeyCode = -1;
+    private long pendingDownTime = -1;
+
+    public KeyInjector(@NonNull Context context) {
+        this.inputManager = (InputManager) context.getSystemService(Context.INPUT_SERVICE);
+
+        // 反射获取 injectInputEvent — @hide API
+        // AOSP 中实际存在的签名只有 (InputEvent, int)，自 API 16 起即有。
+        Method m = null;
+        if (inputManager != null) {
+            try { m = InputManager.class.getMethod("injectInputEvent", InputEvent.class, int.class); } catch (NoSuchMethodException ignored) {}
+            if (m == null) {
+                Log.w(TAG, "injectInputEvent(InputEvent, int) not found");
+            }
+        }
+        this.injectMethod = m;
+    }
+
+    /** 全局开关 */
+    public void setEnabled(boolean on) {
+        this.enabled = on;
+    }
+
+    /**
+     * 注入一次按键事件。
+     *
+     * @param keyValue  MCU 键值
+     * @param keyStatus MCU 键状态
+     */
+    public void inject(int keyValue, int keyStatus) {
+        if (!enabled) return;
+        if (inputManager == null || injectMethod == null) {
+            Log.w(TAG, "InputManager or injectMethod not available, skip inject");
+            return;
+        }
+
+        // 编码器事件
+        if (keyStatus == KEY_STATUS_ENCODER_LEFT
+                || keyStatus == KEY_STATUS_ENCODER_RIGHT) {
+            injectEncoder(keyValue, keyStatus);
+            return;
+        }
+
+        int keyCode = toAndroidKeyCode(keyValue);
+        if (keyCode < 0) return;
+
+        switch (keyStatus) {
+            case KEY_STATUS_SHORT_PRESS: {
+                // 新按键序列，总是分配新的 downTime
+                long now = SystemClock.uptimeMillis();
+                injectKeyEvent(keyCode, KeyEvent.ACTION_DOWN, 0, now);
+                injectKeyEvent(keyCode, KeyEvent.ACTION_UP, 0, now);
+                pendingKeyCode = -1;
+                pendingDownTime = -1;
+                break;
+            }
+            case KEY_STATUS_STUCK: {
+                // 复用同一按键首次按下的 downTime，避免系统认为是不间断的新按下
+                if (keyCode != pendingKeyCode) {
+                    // 首次按下或换键了
+                    pendingKeyCode = keyCode;
+                    pendingDownTime = SystemClock.uptimeMillis();
+                }
+                injectKeyEvent(keyCode, KeyEvent.ACTION_DOWN, 0, pendingDownTime);
+                break;
+            }
+            case KEY_STATUS_RELEASE: {
+                if (keyCode == pendingKeyCode && pendingDownTime >= 0) {
+                    injectKeyEvent(keyCode, KeyEvent.ACTION_UP, 0, pendingDownTime);
+                } else {
+                    // 不匹配或已释放过，fallback：新分配 downTime
+                    long now = SystemClock.uptimeMillis();
+                    injectKeyEvent(keyCode, KeyEvent.ACTION_UP, 0, now);
+                }
+                pendingKeyCode = -1;
+                pendingDownTime = -1;
+                break;
+            }
+            default:
+                Log.d(TAG, "unhandled keyStatus=0x" + Integer.toHexString(keyStatus));
+        }
+    }
+
+    private void injectEncoder(int keyValue, int keyStatus) {
+        int keyCode = toEncoderKeyCode(keyValue);
+        if (keyCode < 0) return;
+        long now = SystemClock.uptimeMillis();
+        injectKeyEvent(keyCode, KeyEvent.ACTION_DOWN, 0, now);
+        injectKeyEvent(keyCode, KeyEvent.ACTION_UP, 0, now);
+    }
+
+    private void injectKeyEvent(int keyCode, int action, int repeatCount, long downTime) {
+        try {
+            long now = SystemClock.uptimeMillis();
+            KeyEvent event = new KeyEvent(downTime, now, action, keyCode, repeatCount);
+            int paramCount = injectMethod.getParameterCount();
+            if (paramCount == 1) {
+                // injectInputEvent(InputEvent)
+                injectMethod.invoke(inputManager, event);
+            } else if (paramCount == 2) {
+                Class<?> secondParam = injectMethod.getParameterTypes()[1];
+                if (secondParam == int.class) {
+                    // injectInputEvent(InputEvent, int) — API 28+
+                    injectMethod.invoke(inputManager, event, 0);
+                } else {
+                    // injectInputEvent(InputEvent, boolean)
+                    injectMethod.invoke(inputManager, event, true);
+                }
+            }
+            Log.v(TAG, "inject keyCode=" + keyCode + " action=" + action + " repeat=" + repeatCount);
+        } catch (Exception e) {
+            Log.w(TAG, "injectInputEvent failed keyCode=" + keyCode + " action=" + action, e);
+        }
+    }
+}
diff --git a/service/src/main/java/com/qsjnic/mcu/service/feature/RadioFeature.java b/service/src/main/java/com/qsjnic/mcu/service/feature/RadioFeature.java
index 0fe2431..df5c593 100644
--- a/service/src/main/java/com/qsjnic/mcu/service/feature/RadioFeature.java
+++ b/service/src/main/java/com/qsjnic/mcu/service/feature/RadioFeature.java
@@ -35,9 +35,18 @@ public final class RadioFeature implements Feature {
             case Cmds.Radio.M2A_FREQ:
                 handleFreq(body);
                 break;
+            case Cmds.Radio.M2A_PS_PTY:
+                handlePsPty(body);
+                break;
+            case Cmds.Radio.M2A_RT:
+                handleRadioText(body);
+                break;
             case Cmds.Radio.M2A_TA_PTY_TIPS:
                 handleTaPtyTips(body);
                 break;
+            case Cmds.Radio.M2A_WORK_STATUS:
+                handleWorkStatus(body);
+                break;
             default:
                 Log.d(TAG, String.format("unknown RADIO cmd=0x%02X", cmd));
         }
@@ -84,6 +93,25 @@ public final class RadioFeature implements Feature {
         broadcast();
     }
 
+    private void handlePsPty(byte[] p) {
+        Object[] v = Decoders.parsePsPty(p);
+        if (v == null) return;
+        final int pi = (Integer) v[0], pty = (Integer) v[1];
+        final String ps = (String) v[2];
+        broadcastTyped(cb -> cb.onPsPty(pi, pty, ps));
+    }
+
+    private void handleRadioText(byte[] p) {
+        String rt = Decoders.parseRadioText(p);
+        broadcastTyped(cb -> cb.onRadioText(rt));
+    }
+
+    private void handleWorkStatus(byte[] p) {
+        int status = Decoders.parseWorkStatus(p);
+        if (status < 0) return;
+        broadcastTyped(cb -> cb.onWorkStatus(status));
+    }
+
     private void handleTaPtyTips(byte[] p) {
         int[] v = Decoders.parseTaPtyTips(p);
         if (v == null) return;
diff --git a/service/src/main/java/com/qsjnic/mcu/service/feature/VehicleFeature.java b/service/src/main/java/com/qsjnic/mcu/service/feature/VehicleFeature.java
index ffa6a99..aa34333 100644
--- a/service/src/main/java/com/qsjnic/mcu/service/feature/VehicleFeature.java
+++ b/service/src/main/java/com/qsjnic/mcu/service/feature/VehicleFeature.java
@@ -66,6 +66,9 @@ public final class VehicleFeature implements Feature {
             case Cmds.Public.M2A_BP_ABNORMAL:
                 broadcastBpAbnormal(Decoders.parseBpAbnormal(body));
                 break;
+            case Cmds.Public.M2A_BATT_INFO:
+                broadcastBattInfo(Decoders.parseBattVoltage(body), Decoders.parseBattPercent(body));
+                break;
             case Cmds.Public.M2A_TFT_DUTY:
                 snapshot.tftDutyPercent = Decoders.parseBacklight(body);
                 broadcastVehicle();
@@ -206,6 +209,7 @@ public final class VehicleFeature implements Feature {
     private void broadcastComTest(byte[] d)     { broadcastTyped(cb -> cb.onComTest(d != null ? d.clone() : null)); }
     private void broadcastTestInfo(byte[] d)    { broadcastTyped(cb -> cb.onTestInfo(d != null ? d.clone() : null)); }
     private void broadcastComTestResponse(byte[] d) { broadcastTyped(cb -> cb.onComTestResponse(d != null ? d.clone() : null)); }
+    private void broadcastBattInfo(int v, int p){ broadcastTyped(cb -> cb.onBattInfo(v, p)); }
     private void broadcastReqPwrOff()           { broadcastTyped(IMcuVehicleListener::onReqPwrOff); }
     private void broadcastStopCharge()          { broadcastTyped(IMcuVehicleListener::onStopCharge); }
     private void broadcastRunNormally()         { broadcastTyped(IMcuVehicleListener::onRunNormally); }
